#include "msp.h"
#include "fifo_function_queue.h"
#include "user_interface.h"
#include "gpio.h"
#include "timer.h"
#include "crystal.h"

void (*task)();

/**
 * main.c
 */

void main(void)
{
	volatile int i;
    WDT_A->CTL = WDT_A_CTL_PW | WDT_A_CTL_HOLD;		// stop watchdog timer

    initFunctionQueue();
    initializeGPIOModule();
    initializeUserInterface();
    initCrystal();
    setTimerTickLimit(1);

    __enable_irq();
	while(1)
    {
        if(!functionQueueIsEmpty())
        {
            task = getFromFunctionQueue();
            task();
        }
        else
        {
     //       __low_power_mode_3();
        }
    }

}
